import java.util.Random;
import java.util.Vector;


public class monitor_example {

	Port myPort = new Port();
	Random rand = new Random();
	
	class martinThread extends Thread {
		int id;

		public martinThread(int eid) {
			id = eid;
		}

		public void run() {
			int time;
			System.out.println("martin id= " + id);
			for (int i = 0; i < 10; i++) {
				time = (rand.nextInt(10) +1) * 1000; //random 1 and 10 seconds
				System.out.println("martin id= " + id + " sleeps for "+time +" milliseconds");
				try { // thread to sleep for 1000 milliseconds is 1 second
					Thread.sleep(time);
				} catch (Exception e) {
					System.out.println(e);
				}
				myPort.enter_port_m();
				time = (rand.nextInt(10) +1) * 1000; //random 1 and 10 seconds
				System.out.println("martin id= " + id + " uses port for "+time+" milliseconds");
				try { // thread to sleep for 1000 milliseconds is 1 second.
					Thread.sleep(time);
				} catch (Exception e) {
					System.out.println(e);
				}
				System.out.println("martin id= " + id + " leaves port (interation "+i+")");
				myPort.exit_port_m();

			}
			System.out.println("martin id= " + id + " has finished.");

		}
	}

	class terranThread extends Thread {
		int id;

		public terranThread(int eid) {
			id = eid;
		}

		public void run() {
			int time;
			System.out.println("terran id= " + id);
			for (int i = 0; i < 10; i++) {
				time = (rand.nextInt(10) +1) * 1000; //random 1 and 10 seconds
				System.out.println("terran id= " + id + " sleeps for "+time+" milliseconds");
				try { // thread to sleep for 1000 milliseconds
					Thread.sleep(time);
				} catch (Exception e) {
					System.out.println(e);
				}
				myPort.enter_port_f();
				time = (rand.nextInt(10) +1) * 1000; //random 1 and 10 seconds
				System.out.println("terran id= " + id + " uses the port for "+time+" milliseconds");
				try { // thread to sleep for 1000 milliseconds
					Thread.sleep(time);
				} catch (Exception e) {
					System.out.println(e);
				}
				System.out.println("terran id= " + id + " leaves the port  (interation "+i+")");
				myPort.exit_port_f();
				
			}
			System.out.println("terran id= " + id + " has finished.");
		}

	}

	monitor_example(int mc, int tc) {
		int i;
        // declare the threads to run
        Vector<martinThread> t1 = new Vector<martinThread>();
        for (i=0; i<mc; i++)
        	t1.add(new martinThread(i) );
        
        Vector<terranThread> t2 = new Vector<terranThread>();
		for (i = 0; i < tc; i++)
			t2.add(new terranThread(i));

		// start the threads
		for (i = 0; i < mc; i++) 
			t1.elementAt(i).start();
		for (i = 0; i < tc; i++)
			t2.elementAt(i).start();
	
		// wait for threads to end here.
		try {
			for (i = 0; i < mc; i++)
				t1.elementAt(i).join();
			for (i = 0; i < tc; i++)
				t2.elementAt(i).join();
			
        } catch ( InterruptedException e) {
          System.out.println("Failed in the joins");
        }
        
        System.out.println("All threads have joined, execution done.");
	}
	
	public static void main(String[] args) {

		if (args.length == 2) {
			new monitor_example(Integer.parseInt(args[0]), Integer.parseInt(args[1]));
		} else {
			new monitor_example(1,1);
		}
	}

}
